summaryrefslogtreecommitdiffstats
path: root/system/ti99sim/ti99sim.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'system/ti99sim/ti99sim.SlackBuild')
-rw-r--r--system/ti99sim/ti99sim.SlackBuild118
1 files changed, 118 insertions, 0 deletions
diff --git a/system/ti99sim/ti99sim.SlackBuild b/system/ti99sim/ti99sim.SlackBuild
new file mode 100644
index 0000000000..40a572a5ea
--- /dev/null
+++ b/system/ti99sim/ti99sim.SlackBuild
@@ -0,0 +1,118 @@
+#!/bin/bash
+
+# Slackware build script for ti99sim
+
+# Written by B. Watson (urchlay@slackware.uk)
+
+# Licensed under the WTFPL. See http://www.wtfpl.net/txt/copying/ for details.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=ti99sim
+VERSION=${VERSION:-0.16.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.src.tar.xz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . -perm /111 -a \! -perm 755 -a -exec chmod 755 {} \+ -o \
+ \! -perm /111 -a \! -perm 644 -a -exec chmod 644 {} \+
+
+# The actual code doesn't need patching, but the build stuff does.
+# Make it show the damn compile commands.
+patch -p1 < $CWD/verbose_compile.diff
+
+# Modify the setup script so it doesn't download anything, and so
+# it installs stuff in $PKG, not ~/.ti99sim.
+patch -p1 < $CWD/setup_paths.diff
+
+# No other way to make it use our flags.
+sed -i "s,-g3 *-O3,$SLKCFLAGS," rules.mak
+
+# Binaries already installed stripped. SYS_BIN must be <DATA_DIR>/bin
+# to avoid it creating absolute symlinks (we'll create relative ones, below).
+env -u ARCH make install DATA_DIR=$PKG/opt/$PRGNAM SYS_BIN=$PKG/opt/$PRGNAM/bin
+
+# Modified setup script requires arguments (original one didn't).
+sh scripts/setup $CWD $PKG/opt/$PRGNAM
+
+# Names are too generic, prefix with ti99sim- unless already prefixed.
+mkdir -p $PKG/usr/bin
+for i in $PKG/opt/$PRGNAM/bin/*; do
+ src=$( basename $i )
+ case "$src" in
+ ti99sim-*) dest=$src ;;
+ *) dest=ti99sim-$src ;;
+ esac
+ ln -s ../../opt/$PRGNAM/bin/$src $PKG/usr/bin/$dest
+done
+
+# Icon cut from TI logo, found here:
+# https://logos.fandom.com/wiki/Texas_Instruments
+for px in 16 22 32 48 64 128; do
+ size="${px}x${px}"
+ dir=$PKG/usr/share/icons/hicolor/$size/apps
+ mkdir -p $dir
+ convert -resize $size $CWD/$PRGNAM.png $dir/$PRGNAM.png
+done
+mkdir -p $PKG/usr/share/pixmaps
+ln -s ../icons/hicolor/48x48/apps/$PRGNAM.png $PKG/usr/share/pixmaps/$PRGNAM.png
+
+# .desktop file by SlackBuild author. It's not that useful since there's no
+# way to attach disk images or cartridges to the emulator after it starts.
+# The .desktop file just starts it up with no media, you can plunk around
+# in BASIC but not save your work. Have to use --dsk1 and other options
+# to actually do anything fun.
+mkdir -p $PKG/usr/share/applications
+cat $CWD/$PRGNAM.desktop > $PKG/usr/share/applications/$PRGNAM.desktop
+
+PKGDOC=$PKG/usr/doc/$PRGNAM-$VERSION
+mkdir -p $PKGDOC
+cp -a doc/* $PKGDOC
+cat $CWD/$PRGNAM.SlackBuild > $PKGDOC/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE